
// -*- C++ -*- automatisch in C++mode wechseln (emacs)
// from gpu gems 2
extern vec3      Param1;
extern vec3      Param2;
extern Image velTexture;

void effects( vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords )
{
    float TwoStage       = Param1.x;
    float Pass_mod_Stage = Param1.y;
    float TwoStage_PmS_1 = Param1.z;
    float Width          = Param2.x;
    float Height         = Param2.y;
    float Pass           = Param2.z;

    // get self
    vec2 OwnPos = texture_coords;
    vec4 self = Texel(texture, OwnPos.xy);
    vec4 selfv = Texel(velTexture, OwnPos.xy);
    float i = floor(OwnPos.x*Width) + floor(OwnPos.y*Height) * Width;

    // my position within the range to merge
    float j = floor(mod(i,TwoStage));

    float compare;

    if ( (j<Pass_mod_Stage) || (j>TwoStage_PmS_1) ) {
        // must copy -> compare with self
        compare = 0.0;
    }else{
        // must sort
        if ( mod((j+Pass_mod_Stage) / Pass,2.0) < 1.0)
            // we are on the left side -> compare with partner on the right
            compare = 1.0;
        else
            // we are on the right side -> compare with partner on the left
            compare = -1.0;
    }

    // get the partner
    float adr = i + compare*Pass;
    vec2 partnerUV = vec2( floor(mod(adr,Width))/Width,floor(adr / Width)/Height );
    vec4 partner = Texel(texture,  partnerUV);
    vec4 partnerV = Texel(velTexture, partnerUV);

    // vec4 partner = Texel(texture, mod(texture_coords+vec2(0.01*compare, 0), vec2(1,1)));
    // vec4 partner = Texel(texture, texture_coords);
    // on the left its a < operation, on the right its a >= operation
    // return vec4(i, 0,0,0);
    
    if((self.a*compare > partner.a*compare)){
        love_Canvases[0] = self;
        love_Canvases[1] = selfv;
    }else{
        love_Canvases[0] = partner;
        love_Canvases[1] = partnerV;
    }
}
