extern vec2 mousePos;
extern float spawnOffset;
extern Image velTexture;
extern Image curlNoise;
extern float particleCount;
extern float particleCountSQRT;
float rand(vec2 co){
		return fract(sin(dot(co.xy ,vec2(12.9898,78.233))) * 43758.5453);
}

void effects(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
{
  float spawnCount = 100;
  float IspawnOffset = mod(spawnOffset*spawnCount, particleCount);
  float particleIndex = mod(texture_coords.x*particleCountSQRT+texture_coords.y*particleCount, particleCount);
  bool spawning = particleIndex>IspawnOffset && particleIndex < IspawnOffset+spawnCount;
  vec4 o = Texel(texture, texture_coords);
  vec3 position = o.xyz;
  float age = o.a;
  if(!spawning && age < 0.001)
    discard;
  vec4 vTex = Texel(velTexture, texture_coords);
  age -= 0.001;
  // age = max(age, 0);
  position.z = 0;
  position.xy += vTex.xy;
  // slow down the particles
  vTex.xy *= 0.94;
  // add gravity
  // vTex.y += sin(spawnOffset*0.0001)*0.0005;

  // get a velocity from the curl noise texture
  vTex.xy += Texel(curlNoise, o.xy*0.75+0.125).xy*0.001*(vTex.a);

  // alternate velocity lookup
  float dist = length(mousePos-o.xy);
  vTex.xy += (mousePos-o.xy)*(vTex.a)*(o.b+2)*0.0008*(1/sqrt(dist))*age;
  // add a velocity vector towards the mouse
  // o.a = 0.1;
  position.z = 0;
  love_Canvases[0] = vec4(position, age);
  love_Canvases[1] = vTex;

  if(spawning){
    // love_Canvases[0] = vec4(mousePos.x, mousePos.y, 0, 1); // 
    vec2 mp = mousePos;
    love_Canvases[0] = vec4(rand(vec2(texture_coords)), rand(vec2(texture_coords)*3), 0, 1); // 
    float pCount = (particleIndex-IspawnOffset)/spawnCount;
  	love_Canvases[1] = vec4(rand(vec2(particleIndex*7, particleIndex*3))*0.1, 0, 0, pCount);
	}
}
